


// **********************************************************************
// *	Programa : Projeto Controla aparelho para mosquito.
// *	Autor : RotNet.
// **********************************************************************




//***********************************************************************
//	Bibliotecas utilizadas:
//=======================================================================

#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <NTPClient.h>
#include <ESP8266WebServer.h>
#include <EEPROM.h>
#include <ESP8266Ping.h>

//***********************************************************************




//***********************************************************************
//
//=======================================================================

//const int PinoD1 = 5;
//const int PinoD2 = 4;
//const int PinoD5 = 14;
//const int PinoD6 = 12;
//const int PinoD7 = 13;

//***********************************************************************




//***********************************************************************
//	Numeracao dos pinos do ESP01 (conforme GPIO "n" do ESP8266):
//=======================================================================

#define	GPIO0	0	// numero do pino "GPIO0".

#define	GPIO2	2	// numero do pino "GPIO2".

#define TX	1	// numero do pino "TX".

#define RX	3	// numero do pino "RX".

//***********************************************************************




//***********************************************************************
//	Mapeamento dos pinos do ESP01 para as Funcoes do Programa:
//
//	- funcao liga/desliga Rele.
//	- funcao "LED Pisca", indicando um "alive" do Sistema.
//	- funcao "PING", indicando resposta a um Ping na Internet.
//	- funcao "CONECTADO", indicando que esta' conectado ao cliente.
//=======================================================================

const int pino_RELE = GPIO0;	// pino usado para acionar o Rele.

const int pino_PISCA = TX;	// pino usado para piscar o LED.

const int pino_PING = GPIO2;	// pino usado para indicar o PING "ok".

const int pino_CONECT = RX;	// pino usado para indicar CONECTADO.

//***********************************************************************




//***********************************************************************
//
//=======================================================================

const char *ssid = "RotNet V";

const char *password = "colorado";

const char titulo = "Controle de mata-mosquito!"

//***********************************************************************




//***********************************************************************
//
//=======================================================================

WiFiUDP ntpUDP;

ESP8266WebServer server(80);

int16_t utc = -3;	// UTC -3:00 , Brazil.

uint32_t currentMillis = 0;
uint32_t previousMillis = 0;

uint32_t currentHour = 0;
uint32_t previousHour = 0;

uint32_t currentMillis2 = 0;
uint32_t previousMillis2 = 0;

//***********************************************************************




//***********************************************************************
//
//=======================================================================

int Ativa;
int Desativa;

//***********************************************************************




//***********************************************************************
//
//=======================================================================

void	EEPROMWriteInt ( int address, int value );

int	EEPROMReadInt ( int address );

//***********************************************************************




//***********************************************************************
//
//=======================================================================

NTPClient timeClient ( ntpUDP, "a.st1.ntp.br", utc*3600, 60000 );

int HORA = 0;
String HCOMPLETA = "";

String estadorele = "";
String txtAtiva = "";
String txtDesativa = "";
String opcao = "";

int manual = 0;
int comando = 0;

//***********************************************************************




//***********************************************************************
//
//=======================================================================

IPAddress staticIP ( 192, 168, 9, 103 );
IPAddress gateway ( 192, 168, 9, 1 );
IPAddress subnet ( 255, 255, 255, 0 );
IPAddress dns1 ( 192, 168, 9, 1 );  

//***********************************************************************




//***********************************************************************
//
//=======================================================================

void	EEPROMWriteInt ( int address, int value )
{
	byte hiByte = highByte ( value );
	byte loByte = lowByte ( value );

	EEPROM.write ( address, hiByte );
	EEPROM.write ( ( address + 1 ), loByte );

	EEPROM.commit();
}
//***********************************************************************




//***********************************************************************
//
//=======================================================================

int	EEPROMReadInt ( int address )
{
	byte hiByte = EEPROM.read ( address );
	byte loByte = EEPROM.read ( address + 1 );
   
	return ( word ( hiByte, loByte ) );
}
//***********************************************************************




//***********************************************************************
//	Check if header is present and correct.
//=======================================================================

bool	is_authentified ()
{
	Serial.println ("Enter is_authentified");

	if ( server.hasHeader("Cookie") )
	{
		Serial.print ("Found cookie: ");
		String cookie = server.header ("Cookie");
		Serial.println ( cookie );

		if ( cookie.indexOf ("ESPSESSIONID=1") != -1 )
		{
			Serial.println ("Authentification Successful");

			return true;
		}
	}

	Serial.println ("Authentification Failed");

	return false;
}
//***********************************************************************




//***********************************************************************
//	Login page, also called for disconnect
//=======================================================================

void	handleLogin ()
{
//--------------------------------------------------
String msg;
//--------------------------------------------------

	if ( server.hasHeader ("Cookie") )
	{
		Serial.print ("Found cookie: ");
		String cookie = server.header ("Cookie");
		Serial.println ( cookie );
	}

	if ( server.hasArg ("DISCONNECT") )
	{
		Serial.println ("Disconnection");
		server.sendHeader ("Location", "/login");
		server.sendHeader ("Cache-Control", "no-cache");
		server.sendHeader ("Set-Cookie", "ESPSESSIONID=0");
		server.send (301);
		return;
	}

	if ( server.hasArg ("USERNAME") && server.hasArg ("PASSWORD") )
	{
		if ( server.arg ("USERNAME") == "luizcarlos" && server.arg ("PASSWORD") == "colorado" )
		{
			server.sendHeader ("Location", "/");
			server.sendHeader ("Cache-Control", "no-cache");
			server.sendHeader ("Set-Cookie", "ESPSESSIONID=1");
			server.send (301);
			Serial.println ("Log in Successful");
			return;
		}

		msg = "       O usuario/senha errado! tente de novo.";
	}

	String content = "<html><head><title>Controle de mata-mosquito!</title>";
	content += "<style>body { background-color: #cccccc; ";
	content += "font-family: Arial, Helvetica, Sans-Serif; ";
	content += "Color: #000088; }</style>";
	content += "</head><body>";
	content += "<form action='/login' method='POST'>Para entrar digite : usuario/senha<br><br>";
	content += "User:<input type='text' name='USERNAME' placeholder='user name'><br><br>";
	content += "Password:<input type='password' name='PASSWORD' placeholder='password'><br><br>";
	content += "<input type='submit' name='SUBMIT' value='Login'>" + msg + "</form><br><br>";
	content += "Para nao entrar clique <a href='/inline'>aqui.</a></body></html>";

	server.send ( 200, "text/html", content );
}
//***********************************************************************




//***********************************************************************
//	Root page can be accessed only if authentification is ok.
//=======================================================================

void	handleRoot ()
{
//--------------------------------------------------
String header;
//--------------------------------------------------
	Serial.println ("Enter handleRoot");

	//Ativa = EEPROMReadInt (1);
	//Desativa = EEPROMReadInt (4);

	if ( !is_authentified() )
	{
		server.sendHeader ("Location", "/login");
		server.sendHeader ("Cache-Control", "no-cache");
		server.send (301);
		return;
	}

	String content = "<html><head><title>Controle de mata-mosquito!</title>";
	content += "<style>body { background-color: #cccccc; ";
	content += "font-family: Arial, Helvetica, Sans-Serif; ";
	content += "Color: #000088; }</style>";
	content += "</head><body>";
	content += "<h1>Controle de mata-mosquito!</h1>";
	content += "<p>Status do Microcontrolador</p>";
	content += "O Estado atual do aparelho :  " + estadorele + "<br><br>";
	content += "Hora do controlador :  " + HCOMPLETA + "<br><br>";
	content += "<form method='POST' action='/form'>";
	content += "<p>Ligar:<input type='text' size='5' name=txtAtiva value=\"";
	content += Ativa;
	content += "\" /></p>";
	content += "Desligar:<input type='text' size='5' name=txtDesativa value=\"";
	content += Desativa;
	content += "\" /></p><br>";
	content += "<input type='radio' name=opcao value=1> Ligar Manualmente<br>";
	content += "<input type='radio' name=opcao value=20> Desligar Manualmente<br>";
	content += "<input type='radio' name=opcao value=0> Nenhuma<br><br>";
	content += "<input type='submit' name=botao value=Salvar></>""<br>";
	content += "<br>";
	content += "Clique para sair. <a href=\"/login?DISCONNECT=YES\">logoff</a></body></html>";
	content += "</body></html>";

	server.send ( 200, "text/html", content );
}
//***********************************************************************




//***********************************************************************
//
//=======================================================================

//no need authentification
void	handleNotFound ()
{
	String message = "File Not Found\n\n";
	message += "URI: ";
	message += server.uri();
	message += "\nMethod: ";
	message += ( server.method() == HTTP_GET )? "GET" : "POST";
	message += "\nArguments: ";
	message += server.args();
	message += "\n";

	for ( uint8_t i=0; i<server.args(); i++ )
	{
		message += " " + server.argName(i) + ": " + server.arg(i) + "\n";
	}

	server.send ( 404, "text/plain", message );
}
//***********************************************************************




//***********************************************************************
//
//=======================================================================

void	formularioPOST ()
{
// HTML do formulario
	String html = "<html><head><title>Controle de mata-mosquito!</title>";
	html += "<style>body { background-color: #cccccc; ";
	html += "font-family: Arial, Helvetica, Sans-Serif; ";
	html += "Color: #000088; }</style>";
	html += "</head><body>";
	html += "<h1>Controle de mata-mosquito!</h1>";
	html += "<p>Salvar dados</p>";
	html += "<form method='POST' action='/form'>";
	html += "<p><input type=text name=txtEnviar /> ";
	html += "<input type=submit name=botao value=Enviar /></p>";
	html += "</form>";
	html += "<p><a href=/>Pagina Principal</a></p>";
	html += "</body></html>";

// Enviando HTML para o servidor
	server.send ( 200, "text/html", html );
}
//***********************************************************************




//***********************************************************************
//
//=======================================================================

void	formularioGET ()
{
// HTML do formulario
	String content = "<html><head><title>Controle de mata-mosquito!</title>";
	content += "<style>body { background-color: #cccccc; ";
	content += "font-family: Arial, Helvetica, Sans-Serif; ";
	content += "Color: #000088; }</style>";
	content += "</head><body>";
	content += "<h1>Controle de mata-mosquito!</h1>";
	content += "<p>Dados Salvos!</p>";
	content += "<p>";

	if ( server.hasArg ("txtAtiva") )
	{
		content += "<b>Hora Ligar: </b>";
		content += server.arg("txtAtiva");
		Ativa = server.arg ("txtAtiva").toInt();
		EEPROMWriteInt ( 1, Ativa );
	}
	else
	{
		content += "<b>Argumento invalido!</b>";
	}

	content += "</p>";

	if ( server.hasArg ("txtDesativa") )
	{
		content += "<b>Hora Desligar: </b>";
		content += server.arg ("txtDesativa");
		Desativa = server.arg ("txtDesativa").toInt();
		EEPROMWriteInt ( 4, Desativa );
	}
	else
	{
		content += "<b>Argumento invalido!</b>";
	}

	content += "</p>";

	if ( server.arg ("opcao") )
	{
		manual = server.arg ("opcao").toInt();
	}


	content += "<form method='GET' action='/'>";
	content += "<p><input name=button2 type=submit value=Voltar /></p>";
	content += "</form>";
	content += "<p><a href=/>Pagina Principal</a></p>";
	content += "</body></html>";

// Enviando HTML para o servidor
	server.send ( 200, "text/html", content );
}
//***********************************************************************




//***********************************************************************
//
//=======================================================================

void	setup ()
{
	Serial.begin ( 115200 );

	pinMode ( pino_RELE, OUTPUT );
	pinMode ( pino_PISCA, OUTPUT );
	pinMode ( pino_CONECT, OUTPUT );
	pinMode ( pino_PING, OUTPUT );

	EEPROM.begin (12);	// inicia a EEPROM com tamanho de 4 Bytes (minimo).

	Ativa = EEPROMReadInt (1);
	Desativa = EEPROMReadInt (4);

// Limpeza da EEPROM (executado apenas para limpar a memoria).
// IMPORTANTE: Apos a primeira carga, comentar este trecho e efetuar a segunda carga em seguida.
/*
	for ( int nL = 0; nL < espacoEEPROM; nL++ )
	{ 
		EEPROM.write ( nL, 0 );
	}
*/

	WiFi.mode ( WIFI_STA );
	WiFi.begin ( ssid, password );
	Serial.println ("");

	WiFi.config ( staticIP, gateway, subnet , dns1 );

	while ( WiFi.status() != WL_CONNECTED )
	{
		delay (500);
		Serial.print (".");
	}

	Serial.println ("");
	Serial.print ("Connectato ");
	Serial.println ( ssid );
	Serial.print ("IP: ");
	Serial.println ( WiFi.localIP() );

	timeClient.begin();
	timeClient.update();

	digitalWrite ( pino_RELE, LOW );
	digitalWrite ( pino_PING, LOW );
	digitalWrite ( pino_PISCA, LOW );
	digitalWrite ( pino_CONECT, LOW );

	server.on ( "/", handleRoot );
	server.on ( "/login", handleLogin );
	server.on ( "/inline", []() { server.send ( 200, "text/plain", "this works without need of authentification" ); } );

	server.on("/form", HTTP_GET, formularioPOST);
	server.on("/form", HTTP_POST, formularioGET);

	server.onNotFound ( handleNotFound );

// here the list of headers to be recorded
	const char * headerkeys[] = {"User-Agent", "Cookie"} ;
	size_t headerkeyssize = sizeof(headerkeys) / sizeof(char*);

// ask server to track these headers
	server.collectHeaders ( headerkeys, headerkeyssize );
	server.begin();
	Serial.println ("HTTP server started");
}
//***********************************************************************




//***********************************************************************
//
//=======================================================================

void	loop ()
{
	HCOMPLETA = timeClient.getFormattedTime();
	HORA = timeClient.getHours();

//..................................................

	currentMillis2 = millis();	// obtem o tempo atual em [ms].

	if ( currentMillis2 - previousMillis2 > 90000 )	// a cada 90 segundos:
	{
		previousMillis2 = currentMillis2;	// seta nova referencia de tempo.

//		Serial.println ( WiFi.status() );

		if ( WiFi.status() == WL_CONNECTED )	// se esta' conectado:
		{
			digitalWrite ( pino_CONECT, HIGH ); // sinaliza que esta' conectado.
		}
		else
		{
			digitalWrite ( pino_CONECT, LOW ); // sinaliza que NAO esta' conectado.
		}

		bool ret = Ping.ping ("www.google.com"); // "pinga" o Google.

		if (ret)	// se obteve uma resposta "ping":
		{
			digitalWrite ( pino_PING, HIGH ); // sinaliza que obteve resposta.
		}
		else
		{
			digitalWrite ( pino_PING, LOW ); // sinaliza que NAO obteve resposta.
		}
	}

//..................................................

	currentMillis = millis();	// obtem o tempo atual em [ms].

	if ( currentMillis - previousMillis > 500 )	// a cada meio segundo:
	{
		previousMillis = currentMillis;	// seta nova referencia de tempo.

//		Serial.println ( HORA );
//		Serial.println ( HCOMPLETA );
//		Serial.println ( Ativa );
//		Serial.println ( Desativa );
//		Serial.println ( manual );

		digitalWrite ( pino_PISCA, !digitalRead (pino_PISCA) );	// LED "alive".
	}

//..................................................

	currentHour = HORA;	// obtem a hora atual.

	if ( currentHour - previousHour > 1 )	// a cada 1 hora:
	{
		previousHour = currentHour;	// seta nova referencia de Hora.

		Serial.println ( HCOMPLETA );	// reporta a hora atual.

		timeClient.forceUpdate();	// sincroniza a hora via Internet.

		Serial.println ("Acertou a Hora!");	// reporta que acertou a hora.
	}

//..................................................

	if ( Ativa < Desativa )	// se a hora de ligar e' antes da hora de desligar:
	{
		if ( ( HORA >= Ativa ) && ( HORA <= Desativa ) ) // se está dentro do periodo "ligado":
		{
			comando = 1;	// indica que deve ligar o Rele.

			estadorele = "Ligado";	// report a ser retornado via Internet.
		}
		else
		{
			comando = 0;	// indica que deve desligar o Rele.

			estadorele = "Desligado"; // report a ser retornado via Internet.
		}
	}

//..................................................

	if ( Ativa > Desativa )	// se a hora de desligar e' antes da hora de ligar:
	{							// se está dentro do periodo "ligado":
		if ( ( ( HORA <= Ativa ) && ( HORA <= Desativa ) ) || ( ( HORA >= Ativa ) && ( HORA >= Desativa ) ) )
		{
			comando = 1;	// indica que deve ligar o Rele.

			estadorele = "Ligado";	// report a ser retornado via Internet.
		}
		else
		{
			comando = 0;	// indica que deve desligar o Rele.

			estadorele = "Desligado"; // report a ser retornado via Internet.
		}
	}

//..................................................

	switch ( manual )
	{
		case 0:	// nenhum.
		break;

		case 1:	// ligar:
//			comando = 1;
		break;

		case 2:	// desligar:
//			comando = 0;

		default:
		break;
	}

//..................................................

	digitalWrite ( pino_RELE, comando ); // liga ou desliga o Rele, conforme o comando.

	server.handleClient();	// mantem a comunicacao com o cliente. 
}
//***********************************************************************



